=== modified file 'src/com/goldencode/p2j/persist/orm/UnclosablePreparedStatement.java'
--- src/com/goldencode/p2j/persist/orm/UnclosablePreparedStatement.java	2021-01-13 21:04:41 +0000
+++ src/com/goldencode/p2j/persist/orm/UnclosablePreparedStatement.java	2021-06-10 11:58:36 +0000
@@ -369,5 +369,11 @@
       this.target.setBlob(parameterIndex, inputStream); }
    public void setNClob(int parameterIndex, Reader reader) throws SQLException { 
       this.target.setNClob(parameterIndex, reader); }
+
+   @Override
+   public String toString()
+   {
+      return target.toString();
+   }
    
 }

=== modified file 'src/com/goldencode/p2j/ui/BrowseColumnWidget.java'
--- src/com/goldencode/p2j/ui/BrowseColumnWidget.java	2021-04-24 22:09:31 +0000
+++ src/com/goldencode/p2j/ui/BrowseColumnWidget.java	2021-06-10 11:58:36 +0000
@@ -2659,8 +2659,8 @@
    /**
     * Sets the BGCOLOR writable attribute.  Private internal version.
     *
-    * @param    fgColor
-    *           The new value for the FGCOLOR attribute.
+    * @param    bgColor
+    *           The new value for the BGCOLOR attribute.
     */
    private void setBgColorInt(NumberType bgColor)
    {

=== modified file 'src/com/goldencode/p2j/ui/TreeConfig.java'
--- src/com/goldencode/p2j/ui/TreeConfig.java	2021-06-01 19:14:11 +0000
+++ src/com/goldencode/p2j/ui/TreeConfig.java	2021-06-17 18:07:04 +0000
@@ -95,7 +95,7 @@
  * @param <N> 
  *        node type
  */
-public abstract class TreeConfig<N extends TreeNodeEntry>
+public abstract class TreeConfig
 extends WidgetConfigExt
 {
    /** Node id of the currently selected node */
@@ -123,7 +123,7 @@
    public boolean sorted;
 
    /** The flat list of tree nodes */
-   public ArrayList<N> nodes = new ArrayList<>();
+   public List<TreeNodeEntry> nodes = new ArrayList<>();
 
    /** Indentation pixel size */
    public int indentation;
@@ -140,8 +140,8 @@
    /** Flag to toggle expand on ENTER */
    public boolean expandOnEnter;
 
-   /** The current top node */
-   public int topNode;
+   /** The current top node ID or -1 if tree is empty */
+   public int topNode = -1;
 
    /** Flag to toggle expand node icons visibility */
    public boolean showExpandIcon = true;
@@ -205,9 +205,11 @@
 
    /**
     * Create node entry instance.
+    * 
     * @return node entry instance
     */
-   protected abstract Supplier<N> createNodeEntry();
+   protected abstract Supplier<TreeNodeEntry> createNodeEntry();
+   
    /**
     * Create a new config and associate it with the given widget.
     *
@@ -309,7 +311,7 @@
    {
       super.applyConfig(config);
 
-      TreeConfig<N> cfg = (TreeConfig<N>) config;
+      TreeConfig cfg = (TreeConfig) config;
       selectedNodeId = cfg.selectedNodeId;
       textEdit = cfg.textEdit;
       dragDrop = cfg.dragDrop;
@@ -369,7 +371,7 @@
       showExpandIcon       = (booleanAttrs & ATTR_MASK_SHOW_EXPAND_ICON) == ATTR_MASK_SHOW_EXPAND_ICON;
       removeNodeOnCollapse = (booleanAttrs & ATTR_MASK_REM_NODE_COLLAPSE) == ATTR_MASK_REM_NODE_COLLAPSE;
       
-      nodes = new ArrayList<N>((List<N>)readList(in, createNodeEntry()));
+      nodes = new ArrayList<TreeNodeEntry>(readList(in, createNodeEntry()));
       scrollNodeCount = in.readInt();
       draggedNode = in.readInt();
       draggedOverNode = in.readInt();

=== modified file 'src/com/goldencode/p2j/ui/TreeListConfig.java' (properties changed: +x to -x)
--- src/com/goldencode/p2j/ui/TreeListConfig.java	2021-06-07 16:01:45 +0000
+++ src/com/goldencode/p2j/ui/TreeListConfig.java	2021-06-17 18:05:43 +0000
@@ -93,8 +93,8 @@
  * TreeList widget configuration.
  * @param <N> node entry type
  */
-public class TreeListConfig<N extends TreeListNodeEntry>
-extends TreeConfig<N>
+public class TreeListConfig
+extends TreeConfig
 {
    /** List of column configurations, index 0 is the column showing the tree portion of the widget */
    public List<Column> columns = new ArrayList<>();
@@ -189,7 +189,7 @@
    {
       super.applyConfig(config);
 
-      TreeListConfig<N> cfg = (TreeListConfig<N>) config;
+      TreeListConfig cfg = (TreeListConfig) config;
       columns = cfg.columns;
       fixedColumn = cfg.fixedColumn;
       showHeader = cfg.showHeader;
@@ -212,7 +212,7 @@
    {
       super.applyConfig(config);
 
-      final TreeListConfig<N> cfg = (TreeListConfig<N>) config;
+      final TreeListConfig cfg = (TreeListConfig) config;
       fixedColumn = cfg.fixedColumn;
       showHeader = cfg.showHeader;
       triggerColumn = cfg.triggerColumn;
@@ -309,9 +309,9 @@
     * @return node entry instance
     */
    @Override
-   protected Supplier<N> createNodeEntry()
+   protected Supplier<TreeNodeEntry> createNodeEntry()
    {
-      return () -> (N)new TreeListNodeEntry();
+      return () -> new TreeListNodeEntry();
    }
 
    /**

=== modified file 'src/com/goldencode/p2j/ui/TreeListNodeEntry.java'
--- src/com/goldencode/p2j/ui/TreeListNodeEntry.java	2021-06-01 15:53:18 +0000
+++ src/com/goldencode/p2j/ui/TreeListNodeEntry.java	2021-06-16 22:20:48 +0000
@@ -95,6 +95,7 @@
     */
    public TreeListNodeEntry()
    {
+      // no-op
    }
 
    /**
@@ -117,13 +118,10 @@
     * @param   cellIndex
     *          Cell index.
     *
-    * @return  cell value.
-    *
-    * @throws  IndexOutOfBoundsException
-    *          if the index is out of range
+    * @return  cell value or {@code null} if the index is out of range of valid indexes
     */
    @Override
-   public Object getValue(int cellIndex)
+   public Object getValue(final int cellIndex)
    {
       return cellIndex >= 0 && cellIndex < cellValues.size() ? cellValues.get(cellIndex) : null;
    }

=== modified file 'src/com/goldencode/p2j/ui/TreeListNodeResource.java'
--- src/com/goldencode/p2j/ui/TreeListNodeResource.java	2021-06-07 16:01:45 +0000
+++ src/com/goldencode/p2j/ui/TreeListNodeResource.java	2021-06-17 17:48:09 +0000
@@ -79,8 +79,8 @@
  * @param <N> 
  *        node type
  */
-public class TreeListNodeResource<N extends TreeListNodeEntry>
-extends TreeNodeResource<N>
+public class TreeListNodeResource
+extends TreeNodeResource
 implements TreeListNode
 {
    /**
@@ -114,10 +114,10 @@
     * @param   parent
     *          Node parent.
     */
-   public TreeListNodeResource(TreeListWidget<N> treeList,
-                               int nodeId,
-                               String key,
-                               TreeListNodeResource<N> parent)
+   public TreeListNodeResource(final TreeWidgetBase treeList,
+                               final int nodeId,
+                               final String key,
+                               final TreeNodeFace parent)
    {
       super(treeList, nodeId, key, parent);
       cellValues.add("");
@@ -137,11 +137,11 @@
     * @param   parent
     *          Node parent.
     */
-   public TreeListNodeResource(final TreeListWidget<N> treeList,
+   public TreeListNodeResource(final TreeWidgetBase treeList,
                                final int nodeId,
                                final String key,
                                final String text,
-                               final TreeListNodeResource<N> parent)
+                               final TreeNodeFace parent)
    {
       super(treeList, nodeId, key, parent);
       cellStrings.add(text);
@@ -155,7 +155,7 @@
    @Override
    public character getNodeText()
    {
-      return new character((String) cellStrings.get(0));
+      return new character(cellStrings.get(0));
    }
 
    /**
@@ -179,10 +179,10 @@
     * @return  new instance of {@link TreeListNodeEntry}.
     */
    @Override
-   protected N saveToEntry()
+   protected TreeNodeEntry saveToEntry()
    {
-      int parentId = parent != null ? parent.nodeId : Integer.MIN_VALUE;
-      N entry = (N)new TreeListNodeEntry(nodeId, parentId);
+      int parentId = parent != null ? ((TreeNodeResource)parent).nodeId : Integer.MIN_VALUE;
+      TreeListNodeEntry entry = new TreeListNodeEntry(nodeId, parentId);
       super.saveToEntry(entry);
       entry.cellValues.addAll(cellValues);
       entry.cellFGColors.addAll(cellFGColors);
@@ -203,7 +203,7 @@
     * @return the cell value
     */
    public final <T> T getCellValue(final int colIndex,
-                                   final Function<TreeListNodeResource<N>, List<T>> getValues)
+                                   final Function<TreeNodeFace, List<T>> getValues)
    {
       final List<T> values = getValues.apply(this);
       return (colIndex >= values.size()) ? null : values.get(colIndex);
@@ -215,7 +215,7 @@
       {
          case STRING:
          case ICON:
-            return getCellValue(colIndex, n -> n.cellStrings);
+            return getCellValue(colIndex, n -> ((TreeListNodeResource)n).cellStrings);
 
          default:
             TreeWidgetBase.LOG.severe("Node comparing: dataType not supported: " + dataType);

=== modified file 'src/com/goldencode/p2j/ui/TreeListWidget.java' (properties changed: +x to -x)
--- src/com/goldencode/p2j/ui/TreeListWidget.java	2021-06-10 11:50:04 +0000
+++ src/com/goldencode/p2j/ui/TreeListWidget.java	2021-06-17 18:05:42 +0000
@@ -109,8 +109,8 @@
  * @param <N> 
  *        node type
  */
-public class TreeListWidget<N extends TreeListNodeEntry>
-extends TreeWidgetBase<N, TreeListConfig<N>, TreeListNodeResource<N>>
+public class TreeListWidget
+extends TreeWidgetBase
 implements TreeList
 {
    /** Flag marking columns or column position changes are pending */
@@ -143,7 +143,7 @@
     */
    public TreeListWidget(boolean dynamic)
    {
-      this(dynamic, new TreeListConfig<N>());
+      this(dynamic, new TreeListConfig());
 
       clearAll();
 
@@ -160,7 +160,7 @@
     * @param   config
     *          The config to use to create widget.
     */
-   public TreeListWidget(boolean dynamic, TreeListConfig<N> config)
+   public TreeListWidget(boolean dynamic, TreeListConfig config)
    {
       super(dynamic, config);
    }
@@ -176,7 +176,7 @@
    @Override
    public integer getSortedColumns()
    {
-      final List<Column> ccolumns = getAttr("columns", () -> config.columns);
+      final List<Column> ccolumns = getAttr("columns", () -> ((TreeListConfig)config).columns);
       for (int i = ccolumns.size() - 1; i >= 0; i--)
       {
          if(ccolumns.get(i).sort != Sorting.NONE)
@@ -194,7 +194,7 @@
    @Override
    public integer getTriggerColumn()
    {
-      return new integer(getAttr("triggerColumn", () -> config.triggerColumn));
+      return new integer(getAttr("triggerColumn", () -> ((TreeListConfig)config).triggerColumn));
    }
 
    /**
@@ -210,7 +210,7 @@
    {
       // assert colIndex == null && !colIndex.isUnknown();
       final int sortedColumn = colIndex.intValue();
-      final List<Column> ccolumns = getAttr("columns", () -> config.columns);
+      final List<Column> ccolumns = getAttr("columns", () -> ((TreeListConfig)config).columns);
 
       for (int i = ccolumns.size() - 1; i >= 0; i--)
       {
@@ -236,7 +236,7 @@
    @Override
    public integer getSortedColumnCount()
    {
-      return new integer(getAttr("columns", () -> config.columns).stream()
+      return new integer(getAttr("columns", () -> ((TreeListConfig)config).columns).stream()
                .filter(c -> c.sort != Sorting.NONE).count());
    }
 
@@ -257,7 +257,7 @@
     *          Column index. Set negative value or unknown to unfix all columns.
     */
    @Override
-   public void fixColumnsLeft(NumberType colIndex)
+   public void fixColumnsLeft(final NumberType colIndex)
    {
       short newValue = -1;
       if (colIndex != null && !colIndex.isUnknown())
@@ -266,9 +266,9 @@
          newValue = (short) (index < 0 ? -1 : index);
       }
 
-      if (newValue != getAttr("fixedColumn", () -> config.fixedColumn))
+      if (newValue != getAttr("fixedColumn", () -> ((TreeListConfig)config).fixedColumn))
       {
-         pushWidgetAttr("fixedColumn", config.fixedColumn);
+         pushWidgetAttr("fixedColumn", ((TreeListConfig)config).fixedColumn);
       }
    }
 
@@ -302,8 +302,12 @@
     * @return  the column index.
     */
    @Override
-   public integer createColumn(character caption, NumberType dataType, NumberType width,
-            NumberType align, NumberType bgColor, NumberType fgColor)
+   public integer createColumn(final character caption,
+                               final NumberType dataType,
+                               final NumberType width,
+                               final NumberType align,
+                               final NumberType bgColor,
+                               final NumberType fgColor)
    {
       if (!assertKnown(caption, dataType))
       {
@@ -351,7 +355,7 @@
       {
          if (pendingPushColumns)
          {
-            setAttr("columns", config.columns, columns, v -> config.columns = new ArrayList(v));
+            setAttr("columns", ((TreeListConfig)config).columns, columns, v -> ((TreeListConfig)config).columns = new ArrayList(v));
             pendingPushColumns = false;
         }
       }
@@ -368,7 +372,7 @@
    @Override
    public void setColumnCaption(final NumberType index, final character caption)
    {
-      final TreeListConfig.Column col = config.getColumn(index);
+      final TreeListConfig.Column col = ((TreeListConfig)config).getColumn(index);
       if (col == null)
       {
          LOG.warning("Invalid column index: " + index);
@@ -398,7 +402,7 @@
    public integer getColumnWidth(NumberType index)
    {
       flushWidgetAttrs();
-      TreeListConfig.Column col = config.getColumn(index);
+      TreeListConfig.Column col = ((TreeListConfig)config).getColumn(index);
       if (col != null)
       {
          return new integer(col.width);
@@ -425,7 +429,7 @@
          return;
       }
 
-      final TreeListConfig.Column col = config.getColumn(index);
+      final TreeListConfig.Column col = ((TreeListConfig)config).getColumn(index);
       if (col == null)
       {
          LOG.warning("Invalid column index: " + index);
@@ -494,7 +498,7 @@
    @Override
    public logical isShowHeader()
    {
-      return new logical(getAttr("showHeader", () -> config.showHeader));
+      return new logical(getAttr("showHeader", () -> ((TreeListConfig)config).showHeader));
    }
 
    /**
@@ -512,7 +516,7 @@
          return;
       }
 
-      setAttr("showHeader", config.showHeader, value.booleanValue(), (vv) -> config.showHeader = vv);
+      setAttr("showHeader", ((TreeListConfig)config).showHeader, value.booleanValue(), (vv) -> ((TreeListConfig)config).showHeader = vv);
    }
 
    /**
@@ -523,7 +527,7 @@
    @Override
    public character getThousandSeparator()
    {
-      return new character(getAttr("thousandSeparator", () -> config.thousandSeparator));
+      return new character(getAttr("thousandSeparator", () -> ((TreeListConfig)config).thousandSeparator));
    }
 
    /**
@@ -540,7 +544,7 @@
          return;
       }
 
-      setAttr("thousandSeparator", config.thousandSeparator, value.toStringMessage(), (vv) -> config.thousandSeparator = vv);
+      setAttr("thousandSeparator", ((TreeListConfig)config).thousandSeparator, value.toStringMessage(), (vv) -> ((TreeListConfig)config).thousandSeparator = vv);
    }
 
    /**
@@ -551,7 +555,7 @@
    @Override
    public character getDecimalSeparator()
    {
-      return new character(getAttr("decimalSeparator", () -> config.decimalSeparator));
+      return new character(getAttr("decimalSeparator", () -> ((TreeListConfig)config).decimalSeparator));
    }
 
    /**
@@ -568,8 +572,8 @@
          return;
       }
 
-      setAttr("decimalSeparator", config.decimalSeparator, value.toStringMessage(),
-               (vv) -> config.decimalSeparator = vv);
+      setAttr("decimalSeparator", ((TreeListConfig)config).decimalSeparator, value.toStringMessage(),
+               (vv) -> ((TreeListConfig)config).decimalSeparator = vv);
    }
 
    /**
@@ -580,7 +584,7 @@
    @Override
    public character getDateSeparator()
    {
-      return new character(getAttr("dateSeparator", () -> config.dateSeparator));
+      return new character(getAttr("dateSeparator", () -> ((TreeListConfig)config).dateSeparator));
    }
 
    /**
@@ -597,7 +601,7 @@
          return;
       }
 
-      setAttr("dateSeparator", config.dateSeparator, value.toStringMessage(), (vv) -> config.dateSeparator = vv);
+      setAttr("dateSeparator", ((TreeListConfig)config).dateSeparator, value.toStringMessage(), (vv) -> ((TreeListConfig)config).dateSeparator = vv);
    }
 
    /**
@@ -608,7 +612,7 @@
    @Override
    public character getShortDateFormat()
    {
-      return new character(getAttr("shortDateFormat", () -> config.shortDateFormat));
+      return new character(getAttr("shortDateFormat", () -> ((TreeListConfig)config).shortDateFormat));
    }
 
    /**
@@ -625,8 +629,8 @@
          return;
       }
 
-      setAttr("shortDateFormat", config.shortDateFormat, value.toStringMessage(), 
-            (vv) -> config.shortDateFormat = vv);
+      setAttr("shortDateFormat", ((TreeListConfig)config).shortDateFormat, value.toStringMessage(), 
+            (vv) -> ((TreeListConfig)config).shortDateFormat = vv);
    }
 
    /**
@@ -641,7 +645,7 @@
    public logical isColumnVisible(NumberType index)
    {
       flushWidgetAttrs();
-      TreeListConfig.Column col = config.getColumn(index);
+      TreeListConfig.Column col = ((TreeListConfig)config).getColumn(index);
       if (col != null)
       {
          return new logical(col.visible);
@@ -665,7 +669,7 @@
          return;
       }
 
-      final TreeListConfig.Column col = config.getColumn(colIndex);
+      final TreeListConfig.Column col = ((TreeListConfig)config).getColumn(colIndex);
       if (col == null)
       {
          return;
@@ -695,7 +699,7 @@
    @Override
    public void setCellIcon(NumberType nodeId, NumberType colIndex, NumberType imgId)
    {
-      setCellValue(nodeId, colIndex, n -> n.cellValues, imgId);
+      setCellValue(nodeId, colIndex, n -> ((TreeListNodeResource)n).cellValues, imgId);
    }
 
    /**
@@ -736,7 +740,7 @@
          return;
       }
 
-      final Object cellValue = getCellValue(nodeId, colIndex, n -> n.cellValues);
+      final Object cellValue = getCellValue(nodeId, colIndex, n -> ((TreeListNodeResource)n).cellValues);
       
       if(cellValue == null)
       {
@@ -761,7 +765,7 @@
    @Override
    public void setCellString(final NumberType nodeId, final NumberType colIndex, final character value)
    {
-      setCellValue(nodeId, colIndex, n -> n.cellValues, value.toStringMessage());
+      setCellValue(nodeId, colIndex, n -> ((TreeListNodeResource)n).cellValues, value.toStringMessage());
    }
 
    /**
@@ -830,7 +834,7 @@
    @Override
    public integer getCellFgColor(NumberType nodeId, NumberType colIndex)
    {
-      final ColorRgb cellValue = getCellValue(nodeId, colIndex, n -> n.cellFGColors);
+      final ColorRgb cellValue = getCellValue(nodeId, colIndex, n -> ((TreeListNodeResource)n).cellFGColors);
       return cellValue != null ? new integer(cellValue.getGuiRgb()) : new integer();
    }
 
@@ -849,7 +853,8 @@
    @Override
    public integer getCellBgColor(NumberType nodeId, NumberType colIndex)
    {
-      final ColorRgb cellValue = getCellValue(nodeId, colIndex, n -> n.cellBGColors);
+      final ColorRgb cellValue = getCellValue(nodeId, colIndex,
+               n -> ((TreeListNodeResource) n).cellBGColors);
       return cellValue != null ? new integer(cellValue.getGuiRgb()) : new integer();
    }
 
@@ -880,7 +885,7 @@
     *          the owner's config was modified.
     */
    @Override
-   public void afterConfigUpdate(TreeListConfig beforeUpdate)
+   public void afterConfigUpdate(TreeConfig beforeUpdate)
    {
       super.afterConfigUpdate(beforeUpdate);
       
@@ -894,7 +899,7 @@
        * to compare columns, since no proper equals() method is defined for columns. 
        */
       columns.clear();
-      columns.addAll(config.columns);
+      columns.addAll(((TreeListConfig)config).columns);
    }
 
    /**
@@ -921,11 +926,11 @@
          return new integer();
       }
 
-      final List<Integer> cellImageList = config.cellImageList;
+      final List<Integer> cellImageList = ((TreeListConfig)config).cellImageList;
       final int imageIndex = cellImageList.size();
-      final ArrayList<Integer> newList = new ArrayList<>(cellImageList);
+      final List<Integer> newList = new ArrayList<>(cellImageList);
       newList.add(globalImageId);
-      setAttr("cellImageList", cellImageList, newList, dummy -> config.cellImageList = newList);
+      setAttr("cellImageList", cellImageList, newList, dummy -> ((TreeListConfig)config).cellImageList = newList);
 
       return new integer(imageIndex);
    }
@@ -943,7 +948,8 @@
    @Override
    public void setCellFgColor(final NumberType nodeId, final NumberType colIndex, final NumberType color)
    {
-      setCellValue(nodeId, colIndex, n -> n.cellFGColors, new ColorRgb(color.intValue()));
+      setCellValue(nodeId, colIndex, n -> ((TreeListNodeResource) n).cellFGColors,
+               new ColorRgb(color.intValue()));
    }
 
    /**
@@ -959,7 +965,8 @@
    @Override
    public void setCellBgColor(final NumberType nodeId, final NumberType colIndex, final NumberType color)
    {
-      setCellValue(nodeId, colIndex, n -> n.cellBGColors, new ColorRgb(color.intValue()));
+      setCellValue(nodeId, colIndex, n -> ((TreeListNodeResource) n).cellBGColors,
+               new ColorRgb(color.intValue()));
    }
 
    /**
@@ -975,7 +982,8 @@
       
       if (buildingTree <= 0)
       {
-         setAttr("columns", config.columns, columns, v -> config.columns = new ArrayList(columns));
+         setAttr("columns", ((TreeListConfig) config).columns, columns,
+                  v -> ((TreeListConfig) config).columns = new ArrayList(columns));
          pendingPushColumns = false;
       }
       else
@@ -997,12 +1005,12 @@
     * @return  new node instance.
     */
    @Override
-   protected TreeListNodeResource<N> createNode(final String key,
-                                                final String text, 
-                                                final TreeListNodeResource<N> parent)
+   protected TreeListNodeResource createNode(final String key,
+                                             final String text, 
+                                             final TreeNodeFace parent)
    {
       final int nodeId = getNextNodeId();
-      return new TreeListNodeResource<N>(this, nodeId, key, text, parent);
+      return new TreeListNodeResource(this, nodeId, key, text, parent);
    }
 
    /**
@@ -1019,7 +1027,8 @@
 
       if (buildingTree <= 0)
       {
-         setAttr("columns", config.columns, columns, v -> config.columns = new ArrayList(v));
+         setAttr("columns", ((TreeListConfig) config).columns, columns,
+                  v -> ((TreeListConfig) config).columns = new ArrayList(v));
          pendingPushColumns = false;
       }
       else
@@ -1074,9 +1083,9 @@
     * @return  Reference to node entry object or {@code null} if not found.
     */
    @SuppressWarnings("unused")
-   private TreeListNodeEntry findListNodeEntry(NumberType nodeId)
+   private TreeNodeEntry findListNodeEntry(NumberType nodeId)
    {
-      for (TreeListNodeEntry n : getAttr("nodes", () -> config.nodes))
+      for (TreeNodeEntry n : getAttr("nodes", () -> ((TreeListConfig)config).nodes))
       {
          if (n.nodeId == nodeId.intValue())
          {
@@ -1103,7 +1112,7 @@
     */
    private final <T> void setCellValue(final NumberType nodeId,
                                        final NumberType colIndex,
-                                       final Function<TreeListNodeResource<N>, List<T>> getValues,
+                                       final Function<TreeNodeFace, List<T>> getValues,
                                        final T newValue)
    {
       if (!assertKnown(nodeId, colIndex))
@@ -1111,7 +1120,7 @@
          return;
       }
 
-      final TreeListNodeResource<N> n = findNode(nodeId.intValue());
+      final TreeNodeFace n = findNode(nodeId.intValue());
       if (n == null)
       {
          return;
@@ -1161,20 +1170,20 @@
     */
    private final <T> T getCellValue(final NumberType nodeId,
                                     final NumberType colIndex,
-                                    final Function<TreeListNodeResource<N>, List<T>> getValues)
+                                    final Function<TreeNodeFace, List<T>> getValues)
    {
       if (!assertKnown(nodeId, colIndex))
       {
          return null;
       }
 
-      final TreeListNodeResource<N> n = findNode(nodeId.intValue());
+      final TreeNodeFace n = findNode(nodeId.intValue());
       if (n == null)
       {
          return null;
       }
 
-      return n.getCellValue(colIndex.intValue(), getValues);
+      return ((TreeListNodeResource)n).getCellValue(colIndex.intValue(), getValues);
    }
 
    /**

=== modified file 'src/com/goldencode/p2j/ui/TreeNodeCollection.java'
--- src/com/goldencode/p2j/ui/TreeNodeCollection.java	2020-09-14 13:46:01 +0000
+++ src/com/goldencode/p2j/ui/TreeNodeCollection.java	2021-06-17 16:27:23 +0000
@@ -77,9 +77,9 @@
  *        tree node face type
  */
 @LegacyResource(resource = LegacyResource.TREE_NODE_COLLECTION)
-public interface TreeNodeCollection<T extends TreeNodeFace>
+public interface TreeNodeCollection
 extends WrappedResource,
-        Iterable<T>,
+        Iterable<TreeNodeFace>,
         RemoveNode
 {
    /**

